#ifndef cable_h
#define cable_h

#include "serial.h"

// flags
#define CABLE_RECIEVE	0x01
#define CABLE_TMS_HIGH	0x02
// gpio pin
#define CABLE_GPIO_PROG	1
#define CABLE_GPIO_INIT	2
#define CABLE_GPIO_M1	3
#define CABLE_GPIO_M2	4

#ifdef __cplusplus
extern "C" {
#endif

typedef struct cable *CABLE;

struct cable {
	int  (* open)(CABLE cbl, char * port);
	void (* close)(CABLE cbl, int do_reset);
	void (* delay)(CABLE cbl, int us);
	int  (* put_tdi_bits)(CABLE cbl, uint8_t *buf, int bit_len,
				    int flags, uint8_t *rcv_buf);
	int  (* put_tms_tdi_bits)(CABLE cbl, uint8_t *buf, int bit_len,
				    int flags, uint8_t *rcv_buf);
	int  (* setup_port)(CABLE cbl, int tms, int tdi, int tck);
	int  (* get_tdo_bits)(CABLE cbl, int bit_len, int tdi, uint8_t *rcv_buf);
	int  (* setup_gpio)(CABLE cbl, int bit, int value);
	int  (* get_gpio)(CABLE cbl, int bit);
	int  (* set_bitclock)(CABLE cbl, double bitclock);

	union filedescriptor fd;
	char *cbl_name;
	char *port;
	int baudrate;
	int ispdelay;
	double bitclock;
};

#ifdef __cplusplus
}
#endif

#endif /* cable_h */
