#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <unistd.h>

uint8_t rev[256];

void build_rev() {
	int i,v,j;
	for (i=0; i< 256; i++) {
		v = 0;
		for (j = 0; j < 8; j++) {
			if (i & (1<<j)) v |= (0x80 >> j);
		}
		rev[i] = v;
	}
}

void dump(uint8_t *buf, int addr, int len, int rev_bit) {
	int i,n;
	int match = 0;

	if (!rev[1]) build_rev();

	printf("*** dump ***\n");
	addr &= ~0xf;
	len = (len + 15) >> 4;
	for (n=0; n<len; n++) {
		if (!memcmp(buf+addr, buf+addr -16, 16)) {
			if (!match) {
				printf(" * \n");
			}
			match = 1;
			addr += 16;
			continue;
		}
		match = 0;
		printf("%04x:",addr);
		for (i=0; i<16; i++) {
			printf(" %02x", rev_bit ? rev[buf[addr+i]]
						: buf[addr+i]);
		}
		printf("\n");
		addr += 16;
	}
	printf("****************\n");
}

#if defined (WIN32NATIVE)
#include <windows.h>

static LARGE_INTEGER freq;
static int has_highperf;

static void dtime_init()
{
	SetThreadAffinityMask( GetCurrentThread(), 1 );
	Sleep(1);
        has_highperf=QueryPerformanceFrequency(&freq);
	printf("Freq = %10.3f\n", (double)freq.QuadPart);

}

double dtime()
{
	LARGE_INTEGER time_val;

    if (!has_highperf) dtime_init();
    if (has_highperf) {
	QueryPerformanceCounter(&time_val);
	return (double)time_val.QuadPart / (double)freq.QuadPart;
    }
    return 0.0;
}
#endif
