BEGIN{
	nest = 0;
	is_valid[nest] = 1;
	is_valid_else[nest] = 0;
}
END{
}
/^[ \t]*`define[ \t]*[A-Za-z_][A-Za-z_0-9]*/{
	name = $2;
	if (is_valid[nest]) {
		defined[name] = "yes";
	}
}
/^[ \t]*`undef[ \t]*[A-Za-z_][A-Za-z_0-9]*/{
	name = $2;
	if (is_valid[nest]) {
		defined[name] = "no";
	}
}
/^[ \t]*`include/{
	is_ctrl = 1;
}
/^[ \t]*`ifdef[ \t]*[A-Za-z_][A-Za-z_0-9]*/{
	name = $2;
	nest = nest + 1;
	if (defined[name] == "yes") {
		is_valid[nest] = is_valid[nest-1];
		is_valid_else[nest] = 0;
	} else {
		is_valid[nest] = 0;
		is_valid_else[nest] = is_valid[nest-1];
	}
	is_ctrl = 1;
}
/^[ \t]*`elsif[ \t]*[A-Za-z_][A-Za-z_0-9]*/{
	name = $2;
	if (defined[name] == "yes") {
		is_valid[nest] = is_valid_else[nest] && is_valid[nest-1];
		is_valid_else[nest] = 0;
	} else {
		is_valid[nest] = 0;
		is_valid_else[nest] = is_valid_else[nest] && is_valid[nest-1];
	}
	is_ctrl = 1;
}
/^[ \t]*`else/{
	is_valid[nest] = is_valid_else[nest];
	is_ctrl = 1;
}
/^[ \t]*`endif/{
	nest = nest - 1;
	is_ctrl = 1;
}
{
	if (is_valid[nest] && !is_ctrl && !DEBUG) {
		print $0;
	}
	if (DEBUG) {
		printf("%d %d %s\n",nest, is_valid[nest], $0);
	}
	is_ctrl = 0;
}
